package net.pricefx.formulaengine.scripting.inputbuilder;

import net.pricefx.common.api.InputType;
import net.pricefx.common.api.PriceFxInterface;

/**
 * Builder class for basic input types.
 */
public class SimpleInputBuilder<VT> extends AbstractInputBuilder<SimpleInputBuilder,VT> {

    private final String functionName;

    protected SimpleInputBuilder(InputBuilderContext builderContext, String paramName, InputType inputType, String functionName) {
        super(builderContext, inputType, paramName);
        this.functionName = functionName;
    }

    public SimpleInputBuilder setDataType(String dataType) {
        if(dataType != null)
            cp.addParameterConfigEntry(PriceFxInterface.FIELD_CONTEXTPARAM_CONFIG_DATATYPE, dataType);
        return this;
    }

    public SimpleInputBuilder setFormatType(String formatType) {
        cp.addParameterConfigEntry(PriceFxInterface.FIELD_CONTEXTPARAM_CONFIG_FORMATTYPE, formatType);
        return this;
    }

    public SimpleInputBuilder setInputType(String inputType) {
        cp.addParameterConfigEntry(PriceFxInterface.FIELD_CONTEXTPARAM_CONFIG_INPUTTYPE, inputType);
        return this;
    }

}
